import java.io.*;
import java.net.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class AkentiAccessApplet extends HttpServlet  {

  private String DNameStr,
		 ResourceStr,
		 ConfFileStr,
		 LocalResourceRootStr,
		 cmd,
		 action;
  private String AkentiInfo = null;
  boolean AkentiAccessType = false;


  public void doPost(HttpServletRequest req, HttpServletResponse res)
       throws ServletException, IOException
  {
    try {
      ObjectInputStream objin = new ObjectInputStream(req.getInputStream());
      Object obj = objin.readObject();
      AkentiInfo = (String)obj;
    } catch (ClassNotFoundException e) { };

    doGet(req,res);
  }

  public void doGet(HttpServletRequest req, HttpServletResponse res)
       throws ServletException, IOException
  {

    makingandexecutingScript();

    AkentiAccessCheck();
    AkentiResultDelete();

    String Result_Access = null;
    String Result_Denied = null;
    Result_Access = "Accessed";
    Result_Denied = "Denied";

    if (AkentiAccessType) 
      {
	if ("object".equals(req.getParameter("format"))) {
	ObjectOutputStream out1 = new ObjectOutputStream(res.getOutputStream());
	out1.writeObject(Result_Access); }
      }
    else 
      {
	if ("object".equals(req.getParameter("format"))) {
	ObjectOutputStream out2 = new ObjectOutputStream(res.getOutputStream());
	out2.writeObject(Result_Denied); }
	//	out2.writeObject(DNameStr); }
      }
  }

  public void makingandexecutingScript()
  {
    String dquote = "\"";
    int delimiter1 = 0;
    int delimiter2 = 0;
    int delimiter3 = 0;

    delimiter1 = AkentiInfo.indexOf("[Akenti1]");
    delimiter2 = AkentiInfo.indexOf("[Akenti2]");
    delimiter3 = AkentiInfo.indexOf("[Akenti3]");

    DNameStr = AkentiInfo.substring(0, delimiter1);
    ResourceStr = AkentiInfo.substring(delimiter1+9, delimiter2);
    ConfFileStr = AkentiInfo.substring(delimiter2+9, delimiter3);
    LocalResourceRootStr = AkentiInfo.substring(delimiter3+9, AkentiInfo.length());

    DNameStr = dquote.concat(DNameStr);
    DNameStr = DNameStr.concat(dquote);

    ResourceStr = dquote.concat(ResourceStr);
    ResourceStr = ResourceStr.concat(dquote);

    cmd = "/npac/home/webflow/Akenti/akenti-docs/cgi-bin/akenti_chk_acc -t W -n "+DNameStr+" -r "+ResourceStr+" -f "+ConfFileStr+" -d "+LocalResourceRootStr+" > /npac/home/webflow/Akenti/akenti-docs/cgi-bin/akentiresult";
    String  Akentiscript = "/npac/home/webflow/Akenti/akenti-docs/cgi-bin/akentiscript";
    
    String FileContents = new String("#!/bin/sh -f\n");
    FileContents += cmd+"\n";
  
    int scriptsize = FileContents.length();
    byte[] scriptbuf = new byte[scriptsize];
    FileContents.getBytes(0, scriptsize, scriptbuf, 0);

    File to_file = new File(Akentiscript);
    FileOutputStream to = null;

    try{
      to = new FileOutputStream(to_file);
      to.write(scriptbuf, 0, scriptsize);
    }
    catch(IOException exc){;}
    finally{
      if(to != null) try{ to.close(); } catch(IOException exc) {;}
    }    

    try{
      Process AkentiEnv = Runtime.getRuntime().exec("chmod 777 "+Akentiscript);
      AkentiEnv.waitFor();
      Process AkentiExec = Runtime.getRuntime().exec(Akentiscript);
      AkentiExec.waitFor();
    }
    catch (Exception ex) {
      //      toClient.println("Error: " + ex.toString()+"<BR>");
    }
  }

  public void AkentiAccessCheck() {

    File f = new File("/npac/home/webflow/Akenti/akenti-docs/cgi-bin/akentiresult");
    int size = (int) f.length();
    int bytes_read = 0;
    String tem_data;

    try{
      FileInputStream in = new FileInputStream(f);
      byte[] data = new byte[size];
      while(bytes_read < size)
	bytes_read += in.read(data, bytes_read, size-bytes_read);
      tem_data = new String(data);
      int indexNum = tem_data.indexOf("Allowed actions:");
      action = tem_data.substring(indexNum+16);

      if (action.startsWith("none")) AkentiAccessType = false;
      else if (action.startsWith("read") || action.startsWith("execute") || action.startsWith("write") || action.startsWith("add") || action.startsWith("delete")) AkentiAccessType = true;
      else AkentiAccessType = false;

    } catch (IOException e) {
      // System.err.println("Error: " + e.toString());
    }
  }

  public void AkentiResultDelete() {
    
    String  Akentiresult = "/npac/home/webflow/Akenti/akenti-docs/cgi-bin/akentiresult";
    String  Akentiscript = "/npac/home/webflow/Akenti/akenti-docs/cgi-bin/akentiscript";
 
    try{
      Process AkentiDelete = Runtime.getRuntime().exec("rm -r "+Akentiresult);
      AkentiDelete.waitFor(); 
      Process AkentiSDelete = Runtime.getRuntime().exec("rm -r "+Akentiscript);
      AkentiDelete.waitFor(); 
    }
    catch (Exception ex1) {
      //System.err.println("Error: " + ex1.toString());
    }
  }

  public String getServletInfo() {
    return "Checking access as Akenti Security Servlet";
  }

}

























